#if !defined HAVE_INLINE_H__
#define      HAVE_INLINE_H__


namespace fxtaux
{

template <typename Type>
static inline Type  sign(const Type &x)
// Return sign(x)
{ return  x<0 ? -1 : (x==0?0:1); }

template <typename Type>
static inline Type  sign1(const Type &x)
// Return 1 iff x==0, else sign(x)
{ return  x<0 ? -1 : 1; }

template <typename Type>
static inline int sign_bit(const Type &x)
// Return 1 iff x<0, else 0
{ return  x<0 ? 1 : 0; }

template <typename Type>
static inline Type  abs(const Type &x)
// Return abs(x)
{ return  x>=0 ? x : -x; }

template <typename Type>
static inline Type  sqr(Type x)
{ return  x * x; }


} // end namespace fxtaux

using namespace fxtaux;


#endif // !defined HAVE_INLINE_H__
