#if !defined HAVE_BITCYCLICGRAY_H__
#define      HAVE_BITCYCLICGRAY_H__


#include "fxttypes.h"
#include "bits/bitsperlong.h"
#include "bits/bitrotate.h"


inline ulong bit_cyclic_gray(ulong x)
// Similar to Gray code, but the bit shifted
// out at the right is moved to the highest bit.
// Resulting word has an even number of bits set.
{
    return x ^ bit_rotate_right(x, 1);
}
// -------------------------


inline ulong bit_cyclic_green(ulong x)
// Similar to green code, but the bit shifted
// out at the left is moved to the lowest bit.
// Resulting word has an even number of bits set.
{
    return x ^ bit_rotate_left(x, 1);
}
// -------------------------


inline ulong bit_cyclic_gray(ulong x, ulong n)
// Version for n-bit words
{
    return x ^ bit_rotate_right(x, 1, n);
}
// -------------------------


inline ulong bit_cyclic_green(ulong x, ulong n)
// Version for n-bit words
{
    return x ^ bit_rotate_left(x, 1, n);
}
// -------------------------


#endif  // !defined HAVE_BITCYCLICGRAY_H__
