#if !defined  HAVE_BITGRAYPERMUTE_H__
#define       HAVE_BITGRAYPERMUTE_H__

#include "bits/bitsperlong.h"
#include "fxttypes.h"

#define SH <<

#if  BITS_PER_LONG == 64
static inline ulong rightswap_16(ulong x)
{
    ulong t, ml, mr, s;
    s = 16;
    ml = 0x0000ffff00000000 SH s;
    mr = ml >> s;
    t = ((x & ml) >> s ) | ((x & mr) << s );
    x = (x & ~(ml | mr)) | t;
    return  x;
}
// -------------------------
#endif



static inline ulong rightswap_8(ulong x)
{
    ulong t, ml, mr, s;
    s = 8;
#if  BITS_PER_LONG == 64
    ml = 0x00ff000000ff0000 SH s;
#else
    ml = 0x00ff0000 SH s;
#endif
    mr = ml >> s;
    t = ((x & ml) >> s ) | ((x & mr) << s );
    x = (x & ~(ml | mr)) | t;
    return  x;
}
// -------------------------


static inline ulong rightswap_4(ulong x)
{
    ulong t, ml, mr, s;
    s = 4;
#if  BITS_PER_LONG == 64
    ml = 0x0f000f000f000f00 SH s;
#else
    ml = 0x0f000f00 SH s;
#endif
    mr = ml >> s;
    t = ((x & ml) >> s ) | ((x & mr) << s );
    x = (x & ~(ml | mr)) | t;
    return  x;
}
// -------------------------


static inline ulong rightswap_2(ulong x)
{
    ulong t, ml, mr, s;
    s = 2;
#if  BITS_PER_LONG == 64
    ml = 0x3030303030303030 SH s;
#else
    ml = 0x30303030 SH s;
#endif
    mr = ml >> s;
    t = ((x & ml) >> s ) | ((x & mr) << s );
    x = (x & ~(ml | mr)) | t;
    return  x;
}
// -------------------------


static inline ulong rightswap_1(ulong x)
{
    ulong t, ml, mr, s;
    s = 1;
#if  BITS_PER_LONG == 64
    ml = 0x4444444444444444 SH s;
#else
    ml = 0x44444444 SH s;
#endif
    mr = ml >> s;
    t = ((x & ml) >> s ) | ((x & mr) << s );
    x = (x & ~(ml | mr)) | t;
    return  x;
}
// -------------------------


static inline ulong bit_gray_permute(ulong x)
// Return word with gray-permuted bits.
{
    x = rightswap_1(x);
    x = rightswap_2(x);
    x = rightswap_4(x);
    x = rightswap_8(x);
#if  BITS_PER_LONG == 64
    x = rightswap_16(x);
#endif
    return  x;
}
// -------------------------

static inline ulong bit_inverse_gray_permute(ulong x)
// Inverse of bit_gray_permute()
{
#if  BITS_PER_LONG == 64
    x = rightswap_16(x);
#endif
    x = rightswap_8(x);
    x = rightswap_4(x);
    x = rightswap_2(x);
    x = rightswap_1(x);
    return  x;
}
// -------------------------


#endif  // !defined HAVE_BITGRAYPERMUTE_H__
