#if !defined  HAVE_NEGBIN_H__
#define       HAVE_NEGBIN_H__

#include "fxttypes.h"
#include "bits/bitsperlong.h"

#if  BITS_PER_LONG >= 64
#define MASK 0xaaaaaaaaaaaaaaaaUL
#else
#define MASK 0xaaaaaaaaUL
#endif

inline ulong bin2neg(ulong x)
// binary --> radix(-2)
//.
// hakmem, item 128
{
    ulong m = MASK;
    x += m;
    x ^= m;
    return  x;
}
// -------------------------

inline ulong neg2bin(ulong x)
// radix(-2) --> binary
// inverse of bin2neg()
{
    ulong m = MASK;
    x ^= m;
    x -= m;
    return  x;
}
// -------------------------

#undef MASK


#endif  // !defined HAVE_NEGBIN_H__
