#if !defined  HAVE_BITPOLPRIMITIVE_H__
#define       HAVE_BITPOLPRIMITIVE_H__


#include "fxttypes.h"
#include "mod/factor.h"
#include "bpol/gf2nfuncs.h"


inline ulong test_bitpol_primitive(ulong c, ulong h, const factorization &mfact)
// For an irreducible polynomial c, test whether it is primitive,
//  that is, whether 'x' is of maximal order.
// mfact must be the factorization of the maximal order (2**n-1).
// Return zero of c is primitive.
{

    ulong r = gf2n_order(2UL, c, h, mfact);
    ulong mers = ((h<<1)-1); // == r==2**n-1
    r ^= mers;  // ==0 if r==mers
    return  r;
}
// -------------------------


#endif  // !defined HAVE_BITPOLPRIMITIVE_H__
