#if !defined HAVE_PARTITION_H__
#define      HAVE_PARTITION_H__


#include "fxttypes.h"
//#define partition Partition // grrr, there is a std::partition

class partition
{
public:
    ulong ct_;  // # of partitions found so far
    ulong n_;   // # of values
    ulong i_;   // level in iterative search

    long *pv_;  // values into which to partition
    ulong *pc_; // multipliers for values
    ulong pci_; // temporary for pc_[i_]
    long *r_;   // rest
    long ri_;   // temporary for r_[i_]
    long x_;    // value to partition

public:
    partition(const ulong *pv, ulong n)
        : n_(n==0?1:n)
    {
        pv_ = new long[n_+1];
        for (ulong j=0; j<n_; ++j)  pv_[j] = pv[j];
        pc_ = new ulong[n_+1];
        r_  = new long[n_+1];
    }

    ~partition()
    {
        delete [] pv_;
        delete [] pc_;
        delete [] r_;
    }

    void init(ulong x);  // reset state

    ulong next();  // generate next partition
    ulong next_func(ulong i);  // aux

    ulong count(ulong x);  // count number of partitions
    ulong count_func(ulong i);  // aux

    void dump()  const;
    int  check(ulong i=0)  const;
};
// -------------------------


#endif  // !defined HAVE_PARTITION_H__
