#if !defined  HAVE_CONVOLUTION_H__
#define       HAVE_CONVOLUTION_H__


#include "fxttypes.h"
#include "complextype.h"

//: REAL CONVOLUTION

// convolution/fhtcnvl.cc:
void fht_convolution(double *f, double *g, ulong ldn);
void fht_convolution0(double *f, double *g, ulong ldn);
void fht_convolution_core(const double *x, double *y, ulong ldn, double v=0.0); // aux
void fht_convolution_revbin_permuted_core(const double *x, double *y, ulong ldn, double v=0.0); // aux

// convolution/fhtcnvla.cc:
void fht_auto_convolution(double *f, ulong ldn);
void fht_auto_convolution0(double *f, ulong ldn);
void fht_auto_convolution_core(double *x, ulong ldn, double v=0.0); // aux
void fht_auto_convolution_revbin_permuted_core(double *x, ulong ldn, double v=0.0); // aux

// convolution/fhtnegacnvl.cc:
void fht_negacyclic_convolution(double *f, double *g, ulong ldn);
void fht_negacyclic_convolution_core(const double *f, double *g, ulong ldn, double v=0.0); // aux

// convolution/fhtnegacnvla.cc:
void fht_negacyclic_auto_convolution(double *x, ulong ldn, double v=0.0);
void fht_negacyclic_auto_convolution_core(double *x, ulong ldn, double v=0.0); // aux


// convolution/fftcnvl.cc:
void fht_fft_convolution(double *f, double *g, ulong ldn);
void split_radix_fft_convolution(double *f, double *g, ulong ldn);
void fht_fft_convolution0(double *f, double *g, ulong ldn);
void split_radix_fft_convolution0(double *f, double *g, ulong ldn);
void fft_convolution_core1(const double *x, double *y, ulong ldn, double v=0.0); // aux
void fft_convolution_core2(const double *x, double *y, ulong ldn, double v=0.0); // aux

// convolution/fftcnvla.cc:
void fht_fft_auto_convolution(double *f, ulong ldn);
void split_radix_fft_auto_convolution(double *f, ulong ldn);
void fht_fft_auto_convolution0(double *f, ulong ldn);
void split_radix_fft_auto_convolution0(double *f, ulong ldn);
void fft_auto_convolution_core1(double *x, ulong ldn, double v=0.0); // aux
void fft_auto_convolution_core2(double *x, ulong ldn, double v=0.0); // aux

// convolution/twodimfhtcnvl.cc:
void twodim_fht_convolution_core(const double *f, double *g, ulong nr, ulong nc); // aux


//: COMPLEX CONVOLUTION:
// convolution/cfhtcnvl.cc:
void fht_convolution(Complex *f, Complex *g, ulong ldn);
void fht_convolution0(Complex *f, Complex *g, ulong ldn);
void fht_convolution_core(const Complex *x, Complex *y, ulong ldn, double v=0.0); // aux
void fht_convolution_revbin_permuted_core(const Complex *x, Complex *y, ulong ldn, double v=0.0); // aux

// convolution/cfhtcnvla.cc:
void fht_auto_convolution(Complex *f, ulong ldn);
void fht_auto_convolution0(Complex *f, ulong ldn);
void fht_auto_convolution_core(Complex *x, ulong ldn, double v=0.0); // aux
void fht_auto_convolution_revbin_permuted_core(Complex *x, ulong ldn, double v=0.0); // aux

// convolution/fftcocnvl.cc:
void fft_complex_auto_convolution(Complex *f, ulong ldn, double v=0.0);
void fft_complex_convolution(Complex *f, Complex *g, ulong ldn, double v=0.0);
void fft_complex_auto_convolution(double *fr, double *fi, ulong ldn, double v=0.0);
void fft_complex_convolution(double *fr, double *fi, double *gr, double *gi, ulong ldn, double v=0.0);



// convolution/weightedconv.cc:
void weighted_complex_auto_convolution(double *fr, double *fi, ulong ldn, double w, double v=0.0);
void negacyclic_complex_auto_convolution(double *fr, double *fi, ulong ldn, double v=0.0);
void right_angle_complex_auto_convolution(double *fr, double *fi, ulong ldn, double v=0.0);
void weighted_complex_auto_convolution(Complex *f, ulong ldn, double w, double v=0.0);
void negacyclic_complex_auto_convolution(Complex *f, ulong ldn, double v=0.0);
void right_angle_complex_auto_convolution(Complex *f, ulong ldn, double v=0.0);


// mult/diskcnvla.cc:
void disk_weighted_complex_auto_convolution(int fd1, int fd2,
                                            double *fr, ulong fn, ulong al,
                                            double v, double nx,
                                            int zq1=0, int zq3=0);

// convolution/slowcocnvl.cc:
void slow_complex_convolution(const double *fr, const double *fi,
                              double *gr, double *gi, ulong n);
void slow_complex_auto_convolution(double *fr, double *fi, ulong n);


#endif  // !defined HAVE_CONVOLUTION_H__
