#if !defined  HAVE_MATRIXFFT_H__
#define       HAVE_MATRIXFFT_H__


#include "fxttypes.h"      // ulong
#include "complextype.h"   // Complex


// matrixfft/matrixfft.cc:
void matrix_fft(double *fr, double *fi, ulong ldn, int is);
void matrix_fft0(double *fr, double *fi, ulong ldn, int is);
void matrix_fft(Complex *f, ulong ldn, int is);
void matrix_fft0(Complex *f, ulong ldn, int is);

// matrixfft/rowffts.cc:
void row_ffts(double *fr, double *fi, ulong nr, ulong nc, int is); // aux
void row_weighted_ffts(double *fr, double *fi, ulong nr, ulong nc, int is); // aux
void row_ffts(Complex *f, ulong nr, ulong nc, int is); // aux
void row_weighted_ffts(Complex *f, ulong nr, ulong nc, int is); // aux

// matrixfft/rowcnvls.cc:
void row_weighted_auto_convolutions(double *fr, double *fi, ulong nr, ulong nc, double v); // aux
void row_weighted_auto_convolutions(Complex *f, ulong nr, ulong nc, double v); // aux

// matrixfft/columnffts.cc:
void column_ffts(double *fr, double *fi, ulong nr, ulong nc, int is, int zp, double *tr, double *ti); // aux
void column_ffts(Complex *f, ulong nr, ulong nc, int is, int zp, Complex *tmp); // aux
void column_real_complex_ffts(double *fr, ulong nr, ulong nc, int zp, double *t); // aux
void column_complex_real_ffts(double *fr, ulong nr, ulong nc, double *t); // aux
void column_complex_imag_ffts(const double *fr, double *fi, ulong r, ulong c, double *tmp); // aux


//: Convolutions based on matrix FFT:

// matrixfft/matrixfftcnvla.cc:
void matrix_fft_auto_convolution(double *f, ulong ldn);
void matrix_fft_auto_convolution0(double *f, ulong ldn);
void matrix_fft_auto_convolution(double *f, ulong r, ulong c, int zp=0);

// matrixfft/matrixfftcnvl.cc:
void matrix_fft_convolution(double *f, double *g, ulong ldn);
void matrix_fft_convolution0(double *f, double *g, ulong ldn);
void matrix_fft_convolution(double *f, double *g, ulong r, ulong c, int zp=0);

// matrixfft/matrixfftcocnvla.cc:
void matrix_fft_auto_convolution(Complex *f, ulong ldn);
void matrix_fft_auto_convolution0(Complex *f, ulong ldn);
void matrix_fft_auto_convolution(Complex *f, ulong nr, ulong nc, int zp=0);
void matrix_fft_complex_auto_convolution(double *fr, double *fi, ulong ldn);
void matrix_fft_complex_auto_convolution0(double *fr, double *fi, ulong ldn);
void matrix_fft_complex_auto_convolution(double *fr, double *fi, ulong nr, ulong nc, int zp=0);

#endif  // !defined HAVE_MATRIXFFT_H__
