#if !defined HAVE_PERMMINCHANGE_H__
#define      HAVE_PERMMINCHANGE_H__

#include "fxttypes.h"


class perm_minchange
{
public:
    ulong n_;   // number of elements to permute
    ulong *p_;  // p[n] contains a permutation of {0, 1, ..., n-1}
    ulong *ip_; // ip[n] contains the inverse permutation of p[]
    ulong *d_;  // aux
    ulong *ii_; // aux
    ulong sw1_, sw2_; // index of elements swapped most recently
    ulong idx_; // incremented with each call to next()

public:
    perm_minchange(ulong nn);
    ~perm_minchange();
    void first();

    ulong next()  { return make_next(n_-1); }  // return 0 if on last permutation
    ulong current()  const  { return idx_; }
    ulong sign()  const  { return  idx_ & 1; }  // 0 for sign +1,  1 for sign -1
    const ulong *data()  const  { return p_; }
    const ulong *invdata()  const  { return ip_; }
    void get_swap(ulong &s1, ulong &s2)  const  { s1=sw1_; s2=sw2_; }

protected:
    ulong make_next(ulong m);
};
// -------------------------


#endif  // !defined HAVE_PERMMINCHANGE_H__
