#if !defined HAVE_PERMSTAR_H__
#define      HAVE_PERMSTAR_H__


#include "fxttypes.h"

// define to also compute inverse:
#define PERM_STAR_WITH_INVERSE

class perm_star
//
// algorithm of Gideon Ehrlich, as given in Knuth
//
{
public:
    ulong n_;    // number of elements
    ulong swp_;  // index of element that was swapped (with index 0)
    ulong *a_;   // current permutation
    ulong *b_;   // aux
    ulong *c_;   // aux
#ifdef PERM_STAR_WITH_INVERSE
    ulong *ia_;   // inverse permutation
#endif
    ulong idx_; // incremented with each call to next()

public:
    perm_star(ulong n);

    ~perm_star();

    void first();
    ulong next();
    ulong sign()  const  { return  idx_ & 1; }  // 0 for sign +1,  1 for sign -1

    ulong get_swap()  const  { return swp_; }
    void get_swap(ulong &s1, ulong &s2)  const  { s1=0; s2=swp_; }

    ulong current()  const  { return idx_; }

    const ulong *data()  const  { return a_; }
#ifdef PERM_STAR_WITH_INVERSE
    const ulong *invdata()  const  { return ia_; }
#endif

};
// -------------------------



#endif  // !defined HAVE_PERMSTAR_H__
