#if !defined  HAVE_RANDPERM_H__
#define       HAVE_RANDPERM_H__

#include "aux0/swap.h"
#include "fxttypes.h"

#include <cstdlib>  // rand()


template <typename Type>
void random_permute(Type *f, ulong n)
// Randomly permute the elements of f[].
// Algorithm given by Helmut Herold, attributed to C.L.Robinson.
{
    for (ulong k=1; k<n; ++k)
    {
        ulong r = (ulong)rand();
        r ^= r>>16;  // avoid using low bits of rand alone

        ulong i = r % (k+1);
        swap2(f[k], f[i]);
    }
}
// -------------------------


#endif  // !defined HAVE_RANDPERM_H__
