#if !defined HAVE_SWAPBLOCKS_H__
#define      HAVE_SWAPBLOCKS_H__


#include "fxttypes.h"
#include "perm/reverse.h"

#include "aux0/swap.h"


template <typename Type>
void swap_blocks(Type *f, ulong x1, ulong n1, ulong x2, ulong n2)
// Swap the blocks starting at indices x1 and x1
// n1 and n2 are the block lengths
{
    if ( x1>x2 ) { swap2(x1,x2); swap2(n1,n2); }
    f += x1;
    x2 -= x1;
    reverse(f, x2+n2);     // n := x2 + n2;
    reverse(f, n2);
    reverse(f+n2, x2-n1);  // x2-n1 == n-n1-n2
    reverse(f+x2, n1);     // x2 == n-n2
    // n = x2+n2 == n2+(x2-n1)+n1
}
// -------------------------


#endif // !defined HAVE_SWAPBLOCKS_H__
